# (c) by Chrisber - this is part of Mapload



#
# Classes
#
class Configuration:
	def __init__(self):
		self.data = {}
	
	def parse(self, path):
		def isNextLineSectionStart(index):
			if len(lines) > index + 1:
				return lines[index + 1].startswith("{")
			
			return False
		
		fileobj = open(path, "r")
		lines = [line.strip().rstrip().split("//")[0] for line in filter(lambda line: len(line.strip().rstrip()) and not line.strip().startswith("//"), fileobj)]
		fileobj.close()
		
		current = self.data
		sections = []
		previous = []
		
		for index, line in enumerate(lines):
			if isNextLineSectionStart(index):
				sections.append(line)
				previous.append(current)
				current = {}
				
				continue
			
			if line.startswith("}"):
				prev = previous.pop()
				prev[sections.pop()] = current
				current = prev
				
				continue
			
			if line.count(" ") or line.count("\t"):
				if line.count(" "):
					if line.count("\""):
						char = line[:line.find("\"")].find(" ")
					else:
						char = line.find(" ")
				else:
					if line.count("\""):
						char = line[:line.find("\"")].find("\t")
					else:
						char = line.find("\t")
				
				value = line[char + 1:]
				current[line[:char]] = (value[value.find("\"") + 1:value.rfind("\"")] if value.count("\"") else value).strip()
	
	def get(self, path, default = None):
		current = self.data
		
		for part in path:
			if part in current:
				current = current[part]
			else:
				return default
		
		return current
	
	def getNative(self, datatype, path, default = None):
		result = self.get(path, default)
		
		try:
			result = datatype(result)
		except:
			result = default
		
		return result